---
name: Feature request
about: Request a feature or improvement
title: ''
labels: enhancement
assignees: ''

---

* Please search existing issues before raising a new issue. For questions about MicroPython or for help using MicroPython, or any sort of "how do I?" requests, please use the Discussions tab or raise a documentation request instead.

* Describe the feature you'd like to see added to MicroPython. In particular, what does this feature enable and why is it useful. MicroPython aims to strike a balance between functionality and code size, so please consider whether this feature can be optionally enabled and whether it can be provided in other ways (e.g. pure-Python library).

* For core Python features, where possible please include a link to the relevant PEP.

* For new architectures / ports / boards, please provide links to relevant documentation, specifications, and toolchains. Any information about the popularity and unique features about this hardware would also be useful.

* For features for existing ports (e.g. new peripherals or microcontroller features), please describe which port(s) it applies too, and whether this is could be an extension to the machine API or a port-specific module?

* For drivers (e.g. for external hardware), please link to datasheets and/or existing drivers from other sources.

* Who do you expect will implement the feature you are requesting? Would you be willing to sponsor this work?

* Remove all placeholder text above before submitting.
